shared_context 'mappings' do
  let(:request_key_map) do
    {
      id:                     :jobRequisitionId,
      title:                  :title,
      description:            :description,
      postal_code:            :postalCode,
      apply_type:             :applyType,
      apply_url:              :applyUrl,
      apply_emails:           :applyEmails,
      apply_instructions:     :applyInstructions,
      benefits:               :benefits,
      compensation_currency:  :compensationCurrency,
      compensation_frequency: :compensationFrequency,
      compensation_range_min: :compensationRangeMin,
      compensation_range_max: :compensationRangeMin,
      city:                   :city,
      region:                 :region,
      country:                :country,
      employment_types:       :employmentTypes,
      experience_level:       :experienceLevel,
      years_experience:       :yearsExperience,
      education:              :education,
      compensation_type:      :compensationType,
      compensation_amount:    :compensationAmount,
      garage_company_id:      :companyId,
      start_date:             :startDate,
      end_date:               :endDate,
      travel_percent:         :travelPercent,
      error_email:            :errorEmail,
      destination_post_id:    :destinationPostId
    }
  end

  let(:request_value_map) do
    {
      companyId:        'EieNKiU3EQtPFB7H',
      employmentTypes:  { 'full_time'   => 'fulltime',
                          'part_time'   => 'parttime' },

      experienceLevel:  { 'entry_level' => 'entryLevel',
                          'experienced' => 'experienced',
                          'manager'     => 'manager',
                          'director'    => 'director',
                          'executive'   => 'executive' },

      education:        { 'associates'  => 'associateDegree',
                          'bachelors'   => 'bachelors',
                          'doctorate'   => 'doctorate',
                          'high_school' => 'highschool',
                          'masters'     => 'masters',
                          'no_degree'   => 'noDegreeRequired' }

    }
  end

  let(:response_key_map) do
    {
      id:                       :destination_post_id,
      title:                    :title,
      description:              :description,
      postalCode:               :postal_code,
      applyType:                :apply_type,
      applyUrl:                 :apply_url,
      applyEmails:              :apply_emails,
      applyInstructions:        :apply_instructions,
      benefits:                 :benefits,
      compensationCurrency:     :compensation_currency,
      compensationFrequency:    :compensation_frequency,
      compensationRangeMin:     :compensation_range_max,
      city:                     :city,
      region:                   :region,
      country:                  :country,
      employmentTypes:          :employment_types,
      experienceLevel:          :experience_level,
      yearsExperience:          :years_experience,
      education:                :education,
      compensationType:         :compensation_type,
      compensationAmount:       :compensation_amount,
      companyId:                :garage_company_id,
      startDate:                :start_date,
      endDate:                  :end_date,
      travelPercent:            :travel_percent,
      errorEmail:               :error_email,
      jobRequisitionId:         :job_requisition_id,
      published:                :published,
      jobpostExpiryDate:        :expires_at
    }
  end

  let(:response_value_map) do
    {
      employment_types:  { 'fulltime'   => 'full_time',
                           'parttime'   => 'part_time' },

      experience_level:  { 'entryLevel'  => 'entry_level',
                           'experienced' => 'experienced',
                           'manager'     => 'manager',
                           'director'    => 'director',
                           'executive'   => 'executive' },

      education:        { 'associatesDegree' => 'associates',
                          'bachelors'        => 'bachelors',
                          'doctorate'        => 'doctorate',
                          'highschool'       => 'high_school',
                          'masters'          => 'masters',
                          'noDegreeRequired' => 'no_degree' },
                          
     expires_at:        -> (value) { Time.at(value.to_i) }
    }
  end
end
